﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace XamGrid_sample.ViewModel
{
    public class Item : INotifyPropertyChanged
    {
        private string name;
        private int id;
        private double weight;
        
        public Item()
        {

        }
        public Item(string name, int id, double weight)
        {
            this.Name = name;
            this.Id = id;
            this.Weight = weight;
        }

        public string Name
        {
            get { return name; }
            set
            {
                name = value;
                NotifyPropertyChanged("Name");
            }
        }

        public int Id
        {
            get { return id; }
            set
            {
                id = value;
                NotifyPropertyChanged("Id");
            }
        }

        public double Weight
        {
            get { return weight; }
            set
            {
                weight = value;
                NotifyPropertyChanged("Weight");
            }
        }

        public int? QtyDelivered
        {
            get
            {
                return this.Deliveries.Sum(D => D.Qty);
            }
        }
        private List<Delivery> _Deliveries = null;
        public  List<Delivery> Deliveries
        {
            get
            {
                if (_Deliveries == null)
                    _Deliveries = new List<Delivery>();
                return _Deliveries;
            }
            set
            {
                _Deliveries = value;
            }
        }

        #region Notify Property Changed

        public event PropertyChangedEventHandler PropertyChanged;
        private void NotifyPropertyChanged(string propertyName = "")
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        #endregion // Notify Property Changed 

    }

    public class Delivery
    {
        private int? _Qty=null;
        public int? Qty
        {
            get { return _Qty; }
            set { _Qty = value; NotifyPropertyChanged("Qty"); }
        }
        #region Notify Property Changed

        public event PropertyChangedEventHandler PropertyChanged;
        private void NotifyPropertyChanged(string propertyName = "")
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        #endregion // Notify Property Changed 
    }
}
